Package org.zkoss.zk.ui.ext

## Interface DynamicPropertied

- All Known Subinterfaces:
    `DynamicTag`, `Macro`
  All Known Implementing Classes:
    `A`, `Abbr`, `AbstractTag`, `Address`, `Apply`, `Area`, `Article`, `Aside`, `Audio`, `B`, `Base`, `Bdi`, `Bdo`, `Blockquote`, `Body`, `Br`, `Button`, `Canvas`, `Caption`, `Cite`, `Code`, `Col`, `Colgroup`, `CollectionTemplate`, `ContentTag`, `Data`, `Datalist`, `Dd`, `Del`, `Details`, `Dfn`, `Dialog`, `Div`, `Dl`, `Dt`, `Em`, `Embed`, `Fieldset`, `Figcaption`, `Figure`, `Footer`, `Form`, `H1`, `H2`, `H3`, `H4`, `H5`, `H6`, `Head`, `Header`, `Hgroup`, `Hr`, `Html`, `HtmlMacroComponent`, `HtmlNativeComponent`, `I`, `Iframe`, `Img`, `Include`, `Input`, `Ins`, `Kbd`, `Label`, `Legend`, `Li`, `Link`, `Main`, `Map`, `Mark`, `Menu`, `Meta`, `Meter`, `Nav`, `Noscript`, `Object`, `Ol`, `Optgroup`, `Option`, `Output`, `P`, `Picture`, `Pre`, `Progress`, `Q`, `Raw`, `Rp`, `Rt`, `Ruby`, `S`, `Samp`, `Script`, `Section`, `Select`, `ShadowTemplate`, `Slot`, `Small`, `Source`, `Span`, `Strong`, `Style`, `Sub`, `Summary`, `Sup`, `Table`, `Tbody`, `Td`, `Template`, `Textarea`, `Tfoot`, `Th`, `Thead`, `Time`, `Title`, `Tr`, `Track`, `U`, `Ul`, `Var`, `Video`, `Wbr`, `XmlMacroComponent`, `XmlNativeComponent`

      public interface DynamicPropertied

  Represents a component that supports a range of properties. It is used to simplify the design of a component, such that developers need to implement member functions (setter and getter) for each property it supports.
  Author:
    tomyeh

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.util.Map<java.lang.String,​java.lang.Object>` | `getDynamicProperties()` | Returns all available dynamic properties.
    `java.lang.Object` | `getDynamicProperty​(java.lang.String name)` | Returns the property value of the specified name.
    `boolean` | `hasDynamicProperty​(java.lang.String name)` | Returns whether a dynamic property is defined.
    `void` | `setDynamicProperty​(java.lang.String name, java.lang.Object value)` | Sets a property with the specified name and value.

- - ### Method Detail

    - #### hasDynamicProperty

          boolean hasDynamicProperty​(java.lang.String name)

      Returns whether a dynamic property is defined.

    - #### getDynamicProperty

          java.lang.Object getDynamicProperty​(java.lang.String name)

      Returns the property value of the specified name.

    - #### setDynamicProperty

          void setDynamicProperty​(java.lang.String name,
                                  java.lang.Object value)
                           throws WrongValueException

      Sets a property with the specified name and value.

      If a component supports only String-type values, it could use org.zkoss.lang.Objects.toString() to convert the value to a String instance.

      Throws:
        `WrongValueException`

    - #### getDynamicProperties

          default java.util.Map<java.lang.String,​java.lang.Object> getDynamicProperties()

      Returns all available dynamic properties.
      Since:
        10.0.0